<script setup lang="ts">
    import { graphql } from "./../../gql/index";
    import { computed } from "vue";
    import { useQuery, useMutation } from "@vue/apollo-composable";
    import { success } from "./../../plugins/toast";
    import useAuthStore from "./../../stores/auth.ts";

    const authStore = useAuthStore();
    const props = defineProps({
        instructorExtensionId: String,
    });
    // graphql
    const instructorExtensionQueryVariables = computed(() => {
        return {
            id: props.instructorExtensionId,
        };
    });
    const instructorExtensionQuery = graphql(`
        query InstructorExtensionZirkelQuery($id: Uuid = "00000000-0000-0000-0000-000000000000") {
            instructorExtension(id: $id) {
                id
                event {
                    id
                    zirkel {
                        id
                        name
                        instructorExtensionsPublic {
                            id
                        }
                    }
                }
                zirkel {
                    id
                }
            }
        }
    `);
    const { result: resultInstructorExtension } = useQuery(instructorExtensionQuery, instructorExtensionQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const zirkel = computed(() => {
        const zirkel = resultInstructorExtension.value?.instructorExtension!.event!.zirkel ?? [];

        return zirkel.map((a) => {
            return {
                name: a.name,
                id: a.id,
                containsInstructor: (a.instructorExtensionsPublic ?? []).some((extension) => {
                    return extension.id == props.instructorExtensionId;
                }),
            };
        });
    });

    // mutations
    const linkingMutation = graphql(`
        mutation LinkInstructorAndZirkel(
            $zirkelId: Uuid = "00000000-0000-0000-0000-000000000000"
            $instructorExtensionId: Uuid = "00000000-0000-0000-0000-000000000000"
        ) {
            setInstructorExtensionToZirkelRelation(zirkelId: $zirkelId, instructorExtensionId: $instructorExtensionId)
        }
    `);
    const { mutate: linkFunction, onDone: onDoneLinking } = useMutation(linkingMutation, () => ({
        variables: {
            instructorExtensionId: props.instructorExtensionId,
        },
        fetchPolicy: "network-only",
        refetchQueries: [
            {
                query: instructorExtensionQuery,
                variables: instructorExtensionQueryVariables.value,
            },
        ],
        awaitRefetchQueries: true,
    }));
    onDoneLinking(() => {
        success("Als Zirkelleiter hinzugefügt");
    });
    const unlinkingMutation = graphql(`
        mutation UnlinkInstructorAndZirkel(
            $zirkelId: Uuid = "00000000-0000-0000-0000-000000000000"
            $instructorExtensionId: Uuid = "00000000-0000-0000-0000-000000000000"
        ) {
            unsetInstructorExtensionToZirkelRelation(zirkelId: $zirkelId, instructorExtensionId: $instructorExtensionId)
        }
    `);
    const { mutate: unlinkFunction, onDone: onDoneUnlinking } = useMutation(unlinkingMutation, () => ({
        variables: {
            instructorExtensionId: props.instructorExtensionId,
        },
        fetchPolicy: "network-only",
        refetchQueries: [
            {
                query: instructorExtensionQuery,
                variables: instructorExtensionQueryVariables.value,
            },
        ],
        awaitRefetchQueries: true,
    }));
    onDoneUnlinking(() => {
        success("Als Zirkelleiter entfernt");
    });
</script>

<template>
    <v-row class="v-col-12 justify-center mt-4">
        <v-table class="v-col-md-8 v-col-12">
            <tbody>
                <tr v-for="aZirkel in zirkel">
                    <td>{{ aZirkel.name }}</td>
                    <td>
                        <span style="color: rgb(var(--v-theme-fg-green))" v-if="aZirkel.containsInstructor">Ist Leiter</span>
                        <span style="color: rgb(var(--v-theme-fg-red))" v-else>Kein Leiter</span>
                    </td>
                    <td>
                        <template v-if="authStore.hasWriteInstructor">
                            <v-btn
                                v-if="!aZirkel.containsInstructor"
                                @click="
                                    linkFunction({
                                        zirkelId: aZirkel.id,
                                    } as any) // the typescript language server is not happy with setting this, previously this worked and the gql types are set correctly...
                                "
                            >
                                <template v-slot:prepend> <span class="material-symbols-outlined"> add </span></template>
                                Als Zirkelleiter hinzufügen
                            </v-btn>
                            <v-btn
                                v-else
                                @click="
                                    unlinkFunction({
                                        zirkelId: aZirkel.id,
                                    } as any) // the typescript language server is not happy with setting this, previously this worked and the gql types are set correctly...
                                "
                            >
                                <template v-slot:prepend> <span class="material-symbols-outlined"> remove </span></template>
                                Zirkelleiter entfernen
                            </v-btn>
                        </template>
                    </td>
                </tr>
            </tbody>
        </v-table>
    </v-row>
</template>
